# Copyright Nitrokey GmbH
# SPDX-License-Identifier: Apache-2.0 OR MIT

from typing import Any, Optional

class USBContext:
    def __enter__(self) -> "USBContext": ...
    def __exit__(self, exc_type: Any, exc_val: Any, exc_tb: Any) -> None: ...
    def getDeviceList(self) -> list["USBDevice"]: ...
    def getByVendorIDAndProductID(
        self, vendor_id: int, product_id: int
    ) -> Optional["USBDevice"]: ...

class USBDevice:
    def getVendorID(self) -> int: ...
    def getProductID(self) -> int: ...
    def open(self) -> "USBDeviceHandle": ...

class USBDeviceHandle: ...
